/*
 * Fabric3
 * Copyright  2008 Metaform Systems Limited
 *
 * This proprietary software may be used only connection with the Fabric3 license
 * (the License), a copy of which is included in the software or may be
 * obtained at: http://www.metaformsystems.com/licenses/license.html.

 * Software distributed under the License is distributed on an as is basis,
 * without warranties or conditions of any kind.  See the License for the
 * specific language governing permissions and limitations of use of the software.
 * This software is distributed in conjunction with other software licensed under
 * different terms.  See the separate licenses for those programs included in the
 * distribution for the permitted and restricted uses of such software.
 *
 */
package org.fabric3.api.jpa;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.LockModeType;
import javax.persistence.Query;

import org.osoa.sca.annotations.Scope;

/**
 *
 * @version $Revision: 6068 $ $Date: 2008-11-27 23:40:44 +0000 (Thu, 27 Nov 2008) $
 */
@Scope("CONVERSATION")
public class ConversationalDaoImpl<ENTITY, KEY> implements ConversationalDao<ENTITY, KEY> {
    
    protected EntityManager entityManager;

    public void close() {
        // No op
    }

    public ENTITY findById(Class<ENTITY> entityClass, KEY key) {
        return entityManager.find(entityClass, key);
    }

    public ENTITY merge(ENTITY entity) {
        return entityManager.merge(entity);
    }

    public void persist(ENTITY entity) {
        entityManager.persist(entity);
    }

    public void refresh(ENTITY entity) {
        entityManager.refresh(entity);
    }

    public void remove(ENTITY entity) {
        entityManager.remove(entity);
    }

    @SuppressWarnings("unchecked")
    public List<ENTITY> findByNamedQuery(String namedQuery, Class<ENTITY> entityClass, Object... args) {
        
        Query query = entityManager.createNamedQuery(namedQuery);
        int index = 0;
        for (Object arg : args) {
            query.setParameter(++index, arg);
        }
        return (List<ENTITY>) query.getResultList();
    }

    public void flush() {
        entityManager.flush();
    }

    public void lock(ENTITY entity, LockModeType lockModeType) {
        entityManager.lock(entity, lockModeType);
    }

}
